/**
 * 
 */
package com.example.layouttest.presenter;

import com.example.layouttest.event.TourDetailsSelectedEvent;
import com.example.layouttest.view.TourEditorView;
import com.example.layouttest.view.TourEditorViewImpl;
import com.vaadin.event.EventRouter;
import com.vaadin.ui.Panel;

@SuppressWarnings("serial")
public class TourEditorPresenter 
    extends AbstractPresenter<TourEditorView, TourEditorView.Presenter>
    implements Presenter, TourEditorView.Presenter {
    
    EventRouter eventBus;

    public TourEditorPresenter(EventRouter eventBus) {
		super();
		this.eventBus = eventBus;
	}

	@Override
    protected TourEditorView createView() {
        return new TourEditorViewImpl();
    }

    @Override
    public void go(Panel panel) {
        panel.setContent(getView().asLayout());
    }


    @Override
    public void onDetails() {
        eventBus.fireEvent(new TourDetailsSelectedEvent("DETAILS"));
    }
}
