/**
 * 
 */
package com.example.layouttest.view;

import com.vaadin.ui.Alignment;
import com.vaadin.ui.Button;
import com.vaadin.ui.HorizontalLayout;
import com.vaadin.ui.Label;
import com.vaadin.ui.Layout;
import com.vaadin.ui.Panel;
import com.vaadin.ui.TextField;
import com.vaadin.ui.VerticalLayout;
import com.vaadin.ui.Button.ClickEvent;
import com.vaadin.ui.Button.ClickListener;
import com.vaadin.ui.themes.BaseTheme;

@SuppressWarnings("serial")
public class TourDetailsEditorViewImpl 
    extends HorizontalLayout 
    implements TourDetailsEditorView {
    
    private Presenter presenter;
    private Button btnBackToCity;
    /** The placeholder for editors. */
    private Panel editorPanel;
    
    public TourDetailsEditorViewImpl() {
        
        setWidth("100%");
        
        VerticalLayout vLayout = new VerticalLayout();
        vLayout.setSpacing(true);
        vLayout.setWidth("100%");
        addComponent(vLayout);
        vLayout.addComponent(new Label("TourDetailsEditorView"));
        // Buttons
        HorizontalLayout naviPane = new HorizontalLayout();
        naviPane.setStyleName("buttonBar");
        naviPane.setSpacing(true);
        vLayout.addComponent(naviPane);
        
        naviPane.addComponent(new Label("City"));
        btnBackToCity = new Button("BackToCity");
        btnBackToCity.setStyleName(BaseTheme.BUTTON_LINK);
        btnBackToCity.addListener(new ClickListener() {
            
            @Override
            public void buttonClick(ClickEvent event) {
                presenter.onBackToCityClicked();
            }
        });
        naviPane.addComponent(btnBackToCity);
        
        naviPane.addComponent(new Label(" | "));
        
        naviPane.addComponent(new Label("Tour"));
        
        // Main Pane
        HorizontalLayout mainPane = new HorizontalLayout();
        mainPane.setWidth("100%");
        vLayout.addComponent(mainPane);
        
        Label testLabel = new Label("Test label");
        mainPane.addComponent(testLabel);
        mainPane.setExpandRatio(testLabel, 1.0f);
        
        // The editor panel
        this.editorPanel = new Panel();
        this.editorPanel.setWidth("500px");
        this.editorPanel.addComponent(new TextField("Test 1"));
        this.editorPanel.addComponent(new TextField("Test 2"));
        this.editorPanel.addComponent(new TextField("Test 3"));
        //this.editorPanel.setHeight("100%");
        mainPane.addComponent(this.editorPanel);
        mainPane.setComponentAlignment(this.editorPanel, Alignment.TOP_RIGHT);
    }

    @Override
    public void setPresenter(Presenter presenter) {
        this.presenter = presenter;
    }

    @Override
    public Layout asLayout() {
        return this;
    }
}
